library ieee;
use ieee.std_logic_1164.all;

entity synchronizer_chain is
	port (clk : in std_logic;
			areset : in std_logic;
			d : in std_logic;
			q: out std_logic
		  );
end entity synchronizer_chain;

architecture rtl of synchronizer_chain is
signal sync1, sync2 : std_logic;
begin

	process (clk, areset) is
	begin
		if areset = '1' then
			sync1 <= '0';
			sync2 <= '0';
		elsif rising_edge(clk) then
			sync1 <= d;
			sync2 <= sync1;
		end if;
	end process;
	q <= sync2;
	
end architecture rtl;